<?php

namespace Drupal\commerce_better_product_variation_label\Entity;

use Drupal\commerce_product\Entity\ProductVariation as CommerceProductVariation;
use Drupal\commerce_product\Entity\ProductVariationInterface;

/**
 *
 */
class ProductVariation extends CommerceProductVariation implements ProductVariationInterface {

  /**
   * The product variation label separator.
   *
   * @var string
   */
  protected $labelSeparator = ' ';

  /**
   * {@inheritDoc}
   */
  public function label() {
    $applies = $this->getEntityType()->getThirdPartySetting('commerce_better_product_variation_label', 'product_label_prefix', FALSE);
    $parentProduct = $this->getProduct();
    $commerceProductVariationLabel = parent::label();
    if ($applies && !empty($parentProduct) && $parentProduct->label() !== $commerceProductVariationLabel) {
      // If applies, prefix the product variation with the parent product label.
      return $parentProduct->label() . $this->labelSeparator . $commerceProductVariationLabel;
    }

    // Fallback to default label() method otherwise:
    return $commerceProductVariationLabel;
  }

}
